<?php
/*
Plugin Name: SalesGen - Woocommrce Big Data Support
Plugin URI: https://salesgen.io/
Description: Allows you use woocmmerce with big data - fix the meta sql query loop while view order and poduct on admin page
Version: 0.0.2
Author: Anthony Pham - SalesGen.io
Author URI: https://salesgen.io/contact/
*/

/*
 *
 * @package SalesGen
 */

if ( !defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}


add_filter( 'postmeta_form_keys', 'salesgen_postmeta_form_keys', 1, 2);
function salesgen_postmeta_form_keys( $keys = null, $post = null ) {
	global $wpdb, $pagenow;
	
	if ( $pagenow == 'edit.php') return $keys;
	$where = '';

	if ( is_object($post) && in_array( $post->post_type, array('product', 'shop_order')) ) {
		$where = ' WHERE post_id = ' . $post->ID;		
	}

	$limit = apply_filters( 'postmeta_form_limit', 30 );
	$sql   = "SELECT meta_key
		FROM $wpdb->postmeta
		{$where}
		GROUP BY meta_key
		
		HAVING meta_key NOT LIKE '\\_%'
		ORDER BY meta_key
		LIMIT %d";
	$keys  = $wpdb->get_col( $wpdb->prepare( $sql, $limit ) );
	return $keys;
}


add_action('wp_dashboard_setup', 'salesgen_disable_woocommerce_status', 99);
add_action('wp_dashboard_setup', 'salesgen_disable_admin_dashboard_setup_widget', 99);

function salesgen_disable_woocommerce_status() {
	remove_meta_box('woocommerce_dashboard_status', 'dashboard', 'normal');
}

function salesgen_disable_admin_dashboard_setup_widget() {
	remove_meta_box( 'wc_admin_dashboard_setup', 'dashboard', 'normal');
}
